Package: rpivotTable
Title: Build Powerful Pivot Tables and Dynamically Slice & Dice your
        Data
Date: 2026-08-06
Version: 0.4.0
Authors@R: c(
    person("Enzo", "Martoglio", role = c("aut")),
    person("Nicolas", "Kruchten", role = c("ctb", "cph")),
    person("Nagarajan", "Chinnasamy", role = c("ctb", "cph")),
    person("Kenton", "Russell", role = c("ctb")),
    person("Lily", "Clements", role = c("cre"), email = "lily@idems.international")
    )
Maintainer: Lily Clements  <lily@idems.international>
Description: Build powerful pivot tables (aka Pivot Grid, Pivot Chart, Cross-Tab)
    and dynamically slice & dice / drag 'n' drop your data. 'rpivotTable' is a
    wrapper of 'pivottable', a powerful open-source Pivot Table library implemented
    in 'JavaScript' by Nicolas Kruchten. Aligned to 'pivottable' v2.19.0.
Depends: R (>= 3.2.0)
Imports: htmlwidgets (>= 0.5)
Suggests: data.table, devtools, dplyr, htmltools, knitr, rmarkdown,
        testthat, tibble
Enhances: shiny (>= 0.12)
License: MIT + file LICENSE
Encoding: UTF-8
URL: https://github.com/smartinsightsfromdata,
        https://github.com/idemsinternational
VignetteBuilder: knitr
RoxygenNote: 7.3.2
NeedsCompilation: no
Packaged: 2026-08-24 14:20:17 UTC; lclem
Author: Enzo Martoglio [aut],
  Nicolas Kruchten [ctb, cph],
  Nagarajan Chinnasamy [ctb, cph],
  Kenton Russell [ctb],
  Lily Clements [cre]
Repository: CRAN
Date/Publication: 2026-08-24 18:50:10 UTC
Built: R 4.5.2; ; 2026-08-24 22:40:35 UTC; unix

# tests/examples for rpivotTable
#   eventually make some of these official tests

# devtools::install_github("smartinsightswithdata/rpivotTable")
library(rpivotTable)

# use Titanic dataset provided in base R
# simple creation with just data
rpivotTable( Titanic )

# prepopulate a row
#   with one - need to make sure passed as array (auto_unbox = F)
rpivotTable( Titanic, rows = "Class" )
# prepopulate multiple rows
rpivotTable( Titanic, rows = c("Class","Sex" ) )
# prepopulate a column
rpivotTable( Titanic, rows = "Class", cols = "Survived" )
# prepopulate multiple columns and multiple rows
rpivotTable( Titanic, rows = c("Class","Sex"), cols = c("Age","Survived" ) )

# prepopulate aggregatorName and vals
rpivotTable(
  Titanic
  , rows = c("Class","Sex")
  , cols = "Survived"
  , aggregatorName = "Sum"
  , vals = "Freq"
)

#  prepopulate with an non-parameter (ie ...)
rpivotTable(
  Titanic
  , rows = c("Class","Sex","Age")
  , cols = "Survived"
  , aggregatorName = "Sum as Fraction of Rows"
  , vals = "Freq"

)

# just another neat example
rpivotTable(
  Titanic
  , rows = "Survived"
  , cols = c("Class","Sex")
  , aggregatorName = "Sum as Fraction of Columns"
  , vals = "Freq"
  , rendererName = "Table Barchart"
)


# let's use Titanic in frequency form now to test this
library(vcdExtra)

titanic_f <- expand.dft( Titanic )

# prepopulate a row
#   with one - need to make sure passed as array (auto_unbox = F)
rpivotTable( titanic_f, rows = "Class" )
# prepopulate multiple rows
rpivotTable( titanic_f, rows = c("Class","Sex" ) )
# prepopulate a column
rpivotTable( titanic_f, rows = "Class", cols = "Survived" )
# prepopulate multiple columns and multiple rows
rpivotTable( titanic_f, rows = c("Class","Sex"), cols = c("Age","Survived" ) )

# just another neat example
rpivotTable(
  titanic_f
  , rows = "Survived"
  , cols = c("Class","Sex")
  , aggregatorName = "Count"
  , rendererName = "Table Barchart"
)
# a check for above
structable(  Class + Sex~Survived, data = Titanic)

rpivotTable(
  titanic_f
  , rows = "Survived"
  , cols = c("Class","Sex")
  , aggregatorName = "Count as Fraction of Total"
  , rendererName = "Table Barchart"
)
prop.table(as.table(structable(  Survived~Class+Sex, data = Titanic)))


# try out d3 renderer
rpivotTable(
  titanic_f
  , rows = c("Survived","Class")
  # cols don't work with treemap
  , aggregatorName = "Count"
  , rendererName = "Treemap"
)


# change locale for non English use
ptbl <- rpivotTable(mtcars)
change_locale(ptbl, "pt")

library(rpivotTable)

rpivotTable(
  Titanic,
  rows = "Survived",
  cols = c("Class","Sex"),
  aggregatorName = "Sum as Fraction of Columns",
  inclusions = list( Survived = list("Yes")),
  exclusions= list( Class = list( "Crew")),
  vals = "Freq",
  rendererName = "Table Barchart"
)

library(rpivotTable)
library(shiny)



list_to_string <- function(obj, listname) {
  if (is.null(names(obj))) {
    paste(listname, "[[", seq_along(obj), "]] = ", obj,
          sep = "", collapse = "\n")
  } else {
    paste(listname, "$", names(obj), " = ", obj,
          sep = "", collapse = "\n")
  }
}

server <- function(input, output) {
  
output$pivotRefresh <- renderText({

cnames <- list("cols","rows","vals", "exclusions","inclusions", "aggregatorName", "rendererName")
# Apply a function to all keys, to get corresponding values
allvalues <- lapply(cnames, function(name) {
  item <- input$myPivotData[[name]]
  if (is.list(item)) {
    list_to_string(item, name)
  } else {
    paste(name, item, sep=" = ")
  }
})
paste(allvalues, collapse = "\n")
})

output$mypivot = renderRpivotTable({
    rpivotTable(
      Titanic,
      rows = "Survived",
      cols = c("Class","Sex"),
      aggregatorName = "Sum as Fraction of Columns",
      exclusions = list(
        Survived = list("No")
        # ,
        # Class = list("1st")
      ),
      vals = "Freq",
      rendererName = "Table Barchart",
      onRefresh=htmlwidgets::JS("function(config) { Shiny.onInputChange('myPivotData', config); }")
      )
  })
}

ui <- shinyUI(fluidPage(
  fluidRow(column(6,   verbatimTextOutput("pivotRefresh")),
           column(6, rpivotTableOutput("mypivot") ))
)
)

shinyApp(ui = ui, server = server)  

library(rpivotTable)
library(shiny)
library(ggvis)
library(dplyr)

canData <- '
Candidate,Party,Province,Age,Gender
"Liu, Laurin",NDP,Quebec,22,Female
"Mourani, Maria",Bloc Quebecois,Quebec,43,Female
"Mars, Silvia",Bloc Quebecois,Quebec,34,Female
"Sellah, Djaouida",NDP,Quebec,,Female
"St-Denis, Lise",NDP,Quebec,72,Female
"Fry, Hedy",Liberal,British Columbia,71,Female
"Turmel, Nycole",NDP,Quebec,70,Female
"Sgro, Judy",Liberal,Ontario,68,Female
"Raynault, Francine",NDP,Quebec,67,Female
"Davidson, Patricia",Conservative,Ontario,66,Female
"Smith, Joy",Conservative,Manitoba,65,Female
"Wong, Alice",Conservative,British Columbia,64,Female
"ONeill Gordon, Tilly",Conservative,New Brunswick,63,Female
"Ablonczy, Diane",Conservative,Alberta,63,Female
"Duncan, Linda Francis",NDP,Alberta,63,Female
"Bennett, Carolyn",Liberal,Ontario,62,Female
"Nash, Peggy",NDP,Ontario,61,Female
"Mathyssen, Irene",NDP,Ontario,61,Female
"Sims, Jinny Jogindera",NDP,British Columbia,60,Female
"Foote, Judy",Liberal,Newfoundland,60,Female
"Crowder, Jean",NDP,British Columbia,60,Female
"Davies, Libby",NDP,British Columbia,59,Female
"Yelich, Lynne",Conservative,Saskatchewan,59,Female
"Day, Anne-Marie",NDP,Quebec,58,Female
"May, Elizabeth",Green,British Columbia,58,Female
"Murray, Joyce",Liberal,British Columbia,58,Female
"Findlay, Kerry-Lynne D.",Conservative,British Columbia,57,Female
"Brown, Lois",Conservative,Ontario,57,Female
"Boutin-Sweet, Marjolaine",NDP,Quebec,57,Female
"Crockatt, Joan",Conservative,Alberta,56,Female
"Chow, Olivia",NDP,Ontario,55,Female
"McLeod, Cathy",Conservative,British Columbia,55,Female
"Finley, Diane",Conservative,Ontario,55,Female
"LeBlanc, Helene",NDP,Quebec,54,Female
"Grewal, Nina",Conservative,British Columbia,54,Female
"Hughes, Carol",NDP,Ontario,54,Female
"Shea, Gail",Conservative,Prince Edward Island,53,Female
"Truppe, Susan",Conservative,Ontario,53,Female
"Young, Wai",Conservative,British Columbia,52,Female'
con <- textConnection(canData)
canadianElections <- read.csv(con, header=TRUE, stringsAsFactors = FALSE)
canadianElections$votes <- round(runif(nrow(canadianElections), min=500, max=15000))

# save(file="./data/canadianElections.rda",canadianElections )

ui = shinyUI(fluidPage(
  fluidRow( rpivotTableOutput("pivot")
  # , fluidRow( ggvisOutput("lgraph") )
)))

server = function(input, output, session) {
reactive({
  canadianElections %>% select(Province,Party,votes) %>% group_by(Party, Province) %>% summarise(votes=sum(votes)) -> candf
    ggvis(canadianElections, ~Province, ~votes, fill = ~ Party) %>%
      layer_bars(width=0.4) %>%  scale_nominal("fill")
}) %>%  bind_shiny("lgraph") 

  output$pivot <- renderRpivotTable({
    rpivotTable(data =   canadianElections   ,  rows = c( "Province"),cols="Party",
                vals = "votes", aggregatorName = "Sum", rendererName = "Table"
                , width="50%", height="550px")
  })
 
}

shinyApp(ui = ui, server = server)

library(rpivotTable)

rpivotTable(HairEyeColor, 
            rows = c("Eye"), 
            cols = c("Hair"),
            rendererName = "Table Barchart",
            aggregatorName="Sum", vals="Freq",
            sorters = "
            function(attr) { 
            var sortAs = $.pivotUtilities.sortAs;
            if (attr == \"Hair\") { 
            return sortAs([\"Red\", \"Brown\", \"Blond\", \"Black\"]);
            } 
            }")

library(shiny)
library(magrittr)
library(rpivotTable)

# based on radio button selection selects the list with specific parameter types
pivot_switch_fn <- function(l_in, type) {
  switch(type,
         choice1 = l_in$l1,
         choice2 = l_in$l2)
}


d_in = data.frame(grp_var1 = rep(letters[1:5], times = 6),
                  grp_var2 = rep(letters[6:8], times = 10),
                  grp_var3 = rep(letters[9:10], times = 15),
                  metric1 = sample.int(n = 100, size = 30),
                  metric2 = sample.int(n = 100, size = 30),
                  metric3 = sample.int(n = 100, size = 30))

l1 = list(l_rows = "grp_var1", 
          l_cols = "grp_var2", 
          l_val = "metric1",
          l_aggregatorName = "Sum",
          l_rendererName = "Table")

l2 = list(l_rows = "grp_var2", 
          l_cols = "grp_var1", 
          l_val = "metric2",
          l_aggregatorName = "Count",
          l_rendererName = "Table Barchart")

l_in = list(l1 = l1, 
            l2 = l2)

rb_levels = list(`Choice 1` = "choice1",
                 `Choice 2` = "choice2")

server = function(input, output) {
  
  output$pivot_setting_rb = renderUI({
    radioButtons(inputId = "pivot_setting", label = "Shortcuts", 
                 choices  = rb_levels)
  })
  
  output$test <- rpivotTable::renderRpivotTable({
    if(length(input$pivot_setting) == 0) return()
    ls = pivot_switch_fn(l_in, input$pivot_setting)
    # print(ls)
    
    ls %$%
      rpivotTable(data = d_in, 
                  rows = l_rows,
                  cols = l_cols,
                  val = l_val,
                  aggregatorName = l_aggregatorName,
                  rendererName = l_rendererName)
    
  })
}

ui =  fluidPage(
  uiOutput("pivot_setting_rb"), br(),br(),br(),
  rpivotTableOutput("test")
) 


shinyApp(ui = ui, server = server, options = list(height = '3000px', width = '100%'))

---
title: "rpivotTable"
author: "Enzo Martoglio"
date: "`r Sys.Date()`"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{rpivotTable}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(echo = TRUE)
```

### rpivotTable:  A pivot table for R

The rpivotTable package is an R [htmlwidget](https://www.htmlwidgets.org/)  built around the [pivottable](https://pivottable.js.org/examples/)  library.

PivotTable.js is a Javascript Pivot Table visualization library with drag'n'drop functionality built on top of jQuery / jQueryUI and  written in CoffeeScript (then compiled to JavaScript) by Nicolas Kruchten at Datacratic. It is available under a MIT license

Many thanks to everyone that contributes bugs and prs, and of course thanks to Nicolas Kruchten for PivotTable.js.

#### Installation

The rpivotTable package depends on  [htmlwidgets](https://github.com/ramnathv/htmlwidgets) package, so you need to install both packages. You can do this using the **devtools** package as follows:

```{r, fig.show='hold'}
# devtools::install_github(c("ramnathv/htmlwidgets", "smartinsightsfromdata/rpivotTable"))
```

Or directly from CRAN:

```{r, fig.show='hold'}
# install.packages('htmlwidgets', 'rpivotTable')
```

#### Usage

Call the package with

```{r, fig.show='hold'}
library(rpivotTable)  # No need to explicitly load htmlwidgets: this is done automatically
```

Just plug in your `data.frame`, `table` or `data.table` to `rpivotTable()`.

It is as simple as this:

```{r, fig.show='hold'}
data(mtcars)
rpivotTable(mtcars,rows="gear", cols=c("cyl","carb"),width="100%", height="400px")
```
The pivot table should appear in your RStudio Viewer or your browser of choice.

For additional technical information please refer to the examples and explanations [here](https://github.com/nicolaskruchten/pivottable/wiki/).

`rpivotTable` parameters decide how the pivot table will look like the firs time it is opened:

* `data` can be a `data.frame` `table` or `data.table`. Nothing else is needed.  If only the data is selected the pivot table opens with nothing on rows and columns (but you can at any time drag and drop any variable in rows or columns at your leasure)
* `rows` and `cols` allow the user to create a report, i.e. to indicate which element will be on rows and columns.
* `aggregatorName` indicates the type of aggregation. Options here are numerous: Count, Count Unique Values, List Unique Values, Sum, Integer Sum, Average, Sum over Sum, 80% Upper Bound, 80% Lower Bound, Sum as Fraction of Total, Sum as Fraction of Rows, Sum as Fraction of Columns, Count as Fraction of Total, Count as Fraction of Rows, Count as Fraction of Columns
* `vals` specifies the variable to use with `aggregatorName` (if any).
* `renderers` dictates the type of graphic rendering used for display, like Table, Treemap etc.
* `sorters` allow to implement a javascript function to specify the ad hoc sorting of certain values. See vignette for an example. It is especially useful with time divisions like days of the week or months of the year (where the alphabetical order does not work)

For example, to display a table with frequency of colour combinations of eyes and hair, you can specify:

```{r}
library(rpivotTable)
data(HairEyeColor)
rpivotTable(data = HairEyeColor, rows = "Hair",cols="Eye", vals = "Freq", aggregatorName = "Sum", rendererName = "Table", width="100%", height="400px")
```


This will display the resulting table. Switching the `aggregatorName` to `Sum as Fraction of Rows` will give the row percentages (and the column totals will give the percentages over the gran total).

To display the `Hair` values in reverse order:

```{r}
library(rpivotTable)
data(HairEyeColor)
rpivotTable(data = HairEyeColor, rows = "Hair",cols="Eye", vals = "Freq", aggregatorName = "Sum", rendererName = "Table", sorters = "
function(attr) {
var sortAs = $.pivotUtilities.sortAs;
if (attr == \"Hair\") { return sortAs([\"Red\", \"Brown\", \"Blond\", \"Black\"]); }
}", width="100%", height="400px")
```

This function could be useful for example to sort time divisions like months of the year or days of the week in their proper, non alphabetical order (thanks to palatinuse for its implementation).

You can also use the very visual new subtotals:

```{r, fig.show='hold'}
data(mtcars)
rpivotTable(mtcars,rows="gear", cols=c("cyl","carb"),subtotals=TRUE, width="100%", height="400px")
```

Or if you want to include it as part of your `dplyr` / `magrittr` pipeline, you can do that also.


```{r, fig.show='hold'}
# suppressMessages(
  library(dplyr)
  # )
iris %>%
filter( Sepal.Width > 3 & Sepal.Length > 5 ) %>%
rpivotTable(rows="Sepal.Width",  rendererName="Treemap")
```
